
### springboot-security
    2.0版本的security默认加上了 csrf 拦截, 所以需要通过重写方法, 把csrf拦截禁用
    解决方法：https://github.com/spring-cloud/spring-cloud-netflix/issues/2754

### spring.application.name 和 eureka.instance.appname比较
    eureka.instance.appname默认使用spring.application.name

### restTemplate客户端使用
    @Configuration 类名上加
	 
	@Bean
	@LoadBalanced
	public RestTemplate getRestTemplate(){
		return new RestTemplate();
	}
	
    RestTemplate rt = getRestTemplate();
    URI order = rt.getForObject("http://eureka-order/eureka-instance", URI.class);

### 注意：只要参数是复杂对象，即使指定GET请求，feign依然会以POST方法进行发送。
    @GetMapping("eureka-instance")
    URI serviceUrl(@RequestBody User user);

### eureka高可用 idea配置步骤
    教程：https://blog.csdn.net/linmengmeng_1314/article/details/85055060
    设置hostname C:\Windows\System32\drivers\etc
    --spring.profiles.active=peer1
    --spring.profiles.active=peer2

### hystrix 健康指标 2.1.x之后配置 
    说明：https://stackoverflow.com/questions/48704018/hystrix-status-is-not-exposed-under-health
### Hystrix 指标流 2.1.x之后配置 
    说明：https://stackoverflow.com/questions/40447916/unable-to-get-hystrix-stream-in-spring-cloud

### 多模块项目打包
    idea默认 mvn clean install:install打包会出问题，使用mvn clean install
    说明：https://stackoverflow.com/questions/6308162/maven-the-packaging-for-this-project-did-not-assign-a-file-to-the-build-artifac

### 使用feign和hystrix回退，
    需要在yml配置文件开启feign断路器，默认关闭
    feign.hystrix.enabled: true

### fallbackFactory和fallback比较
    fallbackFactory 比 fallback 优先级高。同时配置两者，默认使用fallbackFactory
    fallbackFactory 比 fallback力度更高，可以做一些fallback不能做的东西，比如日志

### HystrixDashboard 和 actuator 同时使用导致/hystrix.stream 访问404情况
    注意：我用springboot2.1.8好像并没有出现这种情况
    说明：https://stackoverflow.com/questions/31164210/hystrix-dashboard-not-available-with-jersey-endpoint?r=SearchResults
    解决方法：https://www.jianshu.com/p/b6e9706f382c
    
### turbine监控多个集群
    1，
        turbine:
            aggregator:
                clusterConfig: SYSTEM,USER
            appConfig: customers,stores,ui,admin
            clusterNameExpression: metadata['cluster']
    2，
        turbine:
            aggregator:
                clusterConfig: default
            appConfig: customers,stores,ui,admin
            clusterNameExpression: "'default'"
